#include <proc.h>
#include <cpu.h>

static struct {
  struct process *first;
  struct process *last;
} run_q = {0,0};

static struct process *scheduler_proc;

static struct process *scheduler_next() {
  struct process *ret = run_q.first;
  if(run_q.first && !(run_q.first = run_q.first->q_next))
    run_q.last = 0;
  return ret;
}

void scheduler_insert(struct process *new) {
  if(run_q.last) {
    run_q.last->q_next = new;
    run_q.last = new;
  } else {
    run_q.first = run_q.last = new;
  }
  new->q_next = 0;
}

void scheduler() {
  while(1) {
    struct process *new = 0;
    while(!(new = scheduler_next()));

    current_proc = new;
    write_cr3(new->P4);
    switch_stack(&scheduler_proc->stack_ptr, &new->stack_ptr);

    scheduler_insert(current_proc);
    current_proc = 0;
  }
}

long k_sched_yield(long, long, long, long, long, long) {
  switch_stack(&current_proc->stack_ptr, &scheduler_proc->stack_ptr);
  return 0;
}

void start_scheduler() {
  scheduler_proc = new_process(scheduler);
  scheduler_proc->pid = (uint64_t)-1;

  uint64_t stack;
  switch_stack(&stack, &scheduler_proc->stack_ptr);
}